package wannabit.io.cosmostaion.task.FetchTask;

import retrofit2.Response;
import wannabit.io.cosmostaion.base.BaseApplication;
import wannabit.io.cosmostaion.base.BaseChain;
import wannabit.io.cosmostaion.base.BaseConstant;
import wannabit.io.cosmostaion.network.ApiClient;
import wannabit.io.cosmostaion.network.res.ResOkHistory;
import wannabit.io.cosmostaion.task.CommonTask;
import wannabit.io.cosmostaion.task.TaskListener;
import wannabit.io.cosmostaion.task.TaskResult;
import wannabit.io.cosmostaion.utils.WLog;

public class OkHistoryTask extends CommonTask {
    private String mAddress;
    private BaseChain mChain;

    public OkHistoryTask(BaseApplication app, TaskListener listener, String address, BaseChain chain) {
        super(app, listener);
        this.mResult.taskType   = BaseConstant.TASK_FETCH_OK_HISTORY;
        this.mAddress = address;
        this.mChain = chain;
    }

    @Override
    protected TaskResult doInBackground(String... strings) {
        try {
             if (mChain.equals(BaseChain.OKEX_MAIN)) {
                 Response<ResOkHistory> response = ApiClient.getOkexChain(mApp).getTxHistory(mAddress).execute();
                 if (response.isSuccessful() && response.body() != null) {
                     mResult.resultData = response.body();
                     mResult.isSuccess = true;
                 } else {
                     WLog.w("HistoryTask : NOk");
                 }

             } else if (mChain.equals(BaseChain.OK_TEST)) {
                 Response<ResOkHistory> response = ApiClient.getOkTestChain(mApp).getTxHistory(mAddress).execute();
                 if (response.isSuccessful() && response.body() != null) {
                     mResult.resultData = response.body();
                     mResult.isSuccess = true;
                 } else {
                     WLog.w("HistoryTask : NOk");
                 }

             }

        } catch (Exception e) {
            e.printStackTrace();
            WLog.w("HistoryTask Error " + e.getMessage());
        }
        return mResult;
    }
}