//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: nft/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service for NFT module
///
/// Usage: instantiate `Irismod_Nft_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Irismod_Nft_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Irismod_Nft_QueryClientInterceptorFactoryProtocol? { get }

  func supply(
    _ request: Irismod_Nft_QuerySupplyRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Nft_QuerySupplyRequest, Irismod_Nft_QuerySupplyResponse>

  func owner(
    _ request: Irismod_Nft_QueryOwnerRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Nft_QueryOwnerRequest, Irismod_Nft_QueryOwnerResponse>

  func collection(
    _ request: Irismod_Nft_QueryCollectionRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Nft_QueryCollectionRequest, Irismod_Nft_QueryCollectionResponse>

  func denom(
    _ request: Irismod_Nft_QueryDenomRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Nft_QueryDenomRequest, Irismod_Nft_QueryDenomResponse>

  func denoms(
    _ request: Irismod_Nft_QueryDenomsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Nft_QueryDenomsRequest, Irismod_Nft_QueryDenomsResponse>

  func nFT(
    _ request: Irismod_Nft_QueryNFTRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Nft_QueryNFTRequest, Irismod_Nft_QueryNFTResponse>
}

extension Irismod_Nft_QueryClientProtocol {
  internal var serviceName: String {
    return "irismod.nft.Query"
  }

  /// Supply queries the total supply of a given denom or owner
  ///
  /// - Parameters:
  ///   - request: Request to send to Supply.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func supply(
    _ request: Irismod_Nft_QuerySupplyRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Nft_QuerySupplyRequest, Irismod_Nft_QuerySupplyResponse> {
    return self.makeUnaryCall(
      path: "/irismod.nft.Query/Supply",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeSupplyInterceptors() ?? []
    )
  }

  /// Owner queries the NFTs of the specified owner
  ///
  /// - Parameters:
  ///   - request: Request to send to Owner.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func owner(
    _ request: Irismod_Nft_QueryOwnerRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Nft_QueryOwnerRequest, Irismod_Nft_QueryOwnerResponse> {
    return self.makeUnaryCall(
      path: "/irismod.nft.Query/Owner",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeOwnerInterceptors() ?? []
    )
  }

  /// Collection queries the NFTs of the specified denom
  ///
  /// - Parameters:
  ///   - request: Request to send to Collection.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func collection(
    _ request: Irismod_Nft_QueryCollectionRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Nft_QueryCollectionRequest, Irismod_Nft_QueryCollectionResponse> {
    return self.makeUnaryCall(
      path: "/irismod.nft.Query/Collection",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCollectionInterceptors() ?? []
    )
  }

  /// Denom queries the definition of a given denom
  ///
  /// - Parameters:
  ///   - request: Request to send to Denom.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denom(
    _ request: Irismod_Nft_QueryDenomRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Nft_QueryDenomRequest, Irismod_Nft_QueryDenomResponse> {
    return self.makeUnaryCall(
      path: "/irismod.nft.Query/Denom",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomInterceptors() ?? []
    )
  }

  /// Denoms queries all the denoms
  ///
  /// - Parameters:
  ///   - request: Request to send to Denoms.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denoms(
    _ request: Irismod_Nft_QueryDenomsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Nft_QueryDenomsRequest, Irismod_Nft_QueryDenomsResponse> {
    return self.makeUnaryCall(
      path: "/irismod.nft.Query/Denoms",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomsInterceptors() ?? []
    )
  }

  /// NFT queries the NFT for the given denom and token ID
  ///
  /// - Parameters:
  ///   - request: Request to send to NFT.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func nFT(
    _ request: Irismod_Nft_QueryNFTRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Nft_QueryNFTRequest, Irismod_Nft_QueryNFTResponse> {
    return self.makeUnaryCall(
      path: "/irismod.nft.Query/NFT",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeNFTInterceptors() ?? []
    )
  }
}

internal protocol Irismod_Nft_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'supply'.
  func makeSupplyInterceptors() -> [ClientInterceptor<Irismod_Nft_QuerySupplyRequest, Irismod_Nft_QuerySupplyResponse>]

  /// - Returns: Interceptors to use when invoking 'owner'.
  func makeOwnerInterceptors() -> [ClientInterceptor<Irismod_Nft_QueryOwnerRequest, Irismod_Nft_QueryOwnerResponse>]

  /// - Returns: Interceptors to use when invoking 'collection'.
  func makeCollectionInterceptors() -> [ClientInterceptor<Irismod_Nft_QueryCollectionRequest, Irismod_Nft_QueryCollectionResponse>]

  /// - Returns: Interceptors to use when invoking 'denom'.
  func makeDenomInterceptors() -> [ClientInterceptor<Irismod_Nft_QueryDenomRequest, Irismod_Nft_QueryDenomResponse>]

  /// - Returns: Interceptors to use when invoking 'denoms'.
  func makeDenomsInterceptors() -> [ClientInterceptor<Irismod_Nft_QueryDenomsRequest, Irismod_Nft_QueryDenomsResponse>]

  /// - Returns: Interceptors to use when invoking 'nFT'.
  func makeNFTInterceptors() -> [ClientInterceptor<Irismod_Nft_QueryNFTRequest, Irismod_Nft_QueryNFTResponse>]
}

internal final class Irismod_Nft_QueryClient: Irismod_Nft_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Irismod_Nft_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the irismod.nft.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Irismod_Nft_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service for NFT module
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Irismod_Nft_QueryProvider: CallHandlerProvider {
  var interceptors: Irismod_Nft_QueryServerInterceptorFactoryProtocol? { get }

  /// Supply queries the total supply of a given denom or owner
  func supply(request: Irismod_Nft_QuerySupplyRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Nft_QuerySupplyResponse>

  /// Owner queries the NFTs of the specified owner
  func owner(request: Irismod_Nft_QueryOwnerRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Nft_QueryOwnerResponse>

  /// Collection queries the NFTs of the specified denom
  func collection(request: Irismod_Nft_QueryCollectionRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Nft_QueryCollectionResponse>

  /// Denom queries the definition of a given denom
  func denom(request: Irismod_Nft_QueryDenomRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Nft_QueryDenomResponse>

  /// Denoms queries all the denoms
  func denoms(request: Irismod_Nft_QueryDenomsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Nft_QueryDenomsResponse>

  /// NFT queries the NFT for the given denom and token ID
  func nFT(request: Irismod_Nft_QueryNFTRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Nft_QueryNFTResponse>
}

extension Irismod_Nft_QueryProvider {
  internal var serviceName: Substring { return "irismod.nft.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Supply":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Nft_QuerySupplyRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Nft_QuerySupplyResponse>(),
        interceptors: self.interceptors?.makeSupplyInterceptors() ?? [],
        userFunction: self.supply(request:context:)
      )

    case "Owner":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Nft_QueryOwnerRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Nft_QueryOwnerResponse>(),
        interceptors: self.interceptors?.makeOwnerInterceptors() ?? [],
        userFunction: self.owner(request:context:)
      )

    case "Collection":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Nft_QueryCollectionRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Nft_QueryCollectionResponse>(),
        interceptors: self.interceptors?.makeCollectionInterceptors() ?? [],
        userFunction: self.collection(request:context:)
      )

    case "Denom":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Nft_QueryDenomRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Nft_QueryDenomResponse>(),
        interceptors: self.interceptors?.makeDenomInterceptors() ?? [],
        userFunction: self.denom(request:context:)
      )

    case "Denoms":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Nft_QueryDenomsRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Nft_QueryDenomsResponse>(),
        interceptors: self.interceptors?.makeDenomsInterceptors() ?? [],
        userFunction: self.denoms(request:context:)
      )

    case "NFT":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Nft_QueryNFTRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Nft_QueryNFTResponse>(),
        interceptors: self.interceptors?.makeNFTInterceptors() ?? [],
        userFunction: self.nFT(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Irismod_Nft_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'supply'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeSupplyInterceptors() -> [ServerInterceptor<Irismod_Nft_QuerySupplyRequest, Irismod_Nft_QuerySupplyResponse>]

  /// - Returns: Interceptors to use when handling 'owner'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeOwnerInterceptors() -> [ServerInterceptor<Irismod_Nft_QueryOwnerRequest, Irismod_Nft_QueryOwnerResponse>]

  /// - Returns: Interceptors to use when handling 'collection'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCollectionInterceptors() -> [ServerInterceptor<Irismod_Nft_QueryCollectionRequest, Irismod_Nft_QueryCollectionResponse>]

  /// - Returns: Interceptors to use when handling 'denom'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomInterceptors() -> [ServerInterceptor<Irismod_Nft_QueryDenomRequest, Irismod_Nft_QueryDenomResponse>]

  /// - Returns: Interceptors to use when handling 'denoms'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomsInterceptors() -> [ServerInterceptor<Irismod_Nft_QueryDenomsRequest, Irismod_Nft_QueryDenomsResponse>]

  /// - Returns: Interceptors to use when handling 'nFT'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeNFTInterceptors() -> [ServerInterceptor<Irismod_Nft_QueryNFTRequest, Irismod_Nft_QueryNFTResponse>]
}
